using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
using MySql.Data.MySqlClient;
using fatd_faturamento.ENTIDADE;
using fatd_faturamento.DAL.Conexao;

namespace fatd_faturamento.DAL.Persistencia
{
    public class dalClasse
    {
        string vFILTER = null;
        string vINNERJOIN = null;
        string vAND = null;
        string vORDERBY = null;

        #region Métodos

        public void Insert(entidadeClasse objClasse)
        {
            MySqlCommand cmd = null;
            IGerenciadorTransacao objGerenciadorTransacao = null;
            ConexaoBD objconexaoBD = null;

            try
            {
                objconexaoBD = new ConexaoBD();

                objconexaoBD.SetarConexaoBanco(TipoBDConexao.fat_BD);

                using (objGerenciadorTransacao = FabricaGerenciadorTransacao.GetGerenciador(TipoBDGerenciador.MySql))
                {
                    vFILTER = vFILTER + "CODIGO        = ?CODIGO , ";
                    vFILTER = vFILTER + "DESCRICAO         = ?DESCRICAO,  ";
                    vFILTER = vFILTER + "CONTA_FATURAMENTO          = ?CONTA_FATURAMENTO,  ";
                    vFILTER = vFILTER + "CONTA_FATURAMENTO_PARC          = ?CONTA_FATURAMENTO_PARC  ";


                    cmd = new MySqlCommand(this.QueryInsert);

                    cmd.Parameters.AddWithValue("?CODIGO", objClasse.CODIGO.ToString().ToUpper());
                    cmd.Parameters.AddWithValue("?DESCRICAO", objClasse.DESCRICAO.ToString().ToUpper());
                    cmd.Parameters.AddWithValue("?CONTA_FATURAMENTO", objClasse.CONTA_FATURAMENTO.ToString().ToUpper());
                    cmd.Parameters.AddWithValue("?CONTA_FATURAMENTO_PARC", objClasse.CONTA_FATURAMENTO_PARC.ToString().ToUpper());

                    objGerenciadorTransacao.Execute(cmd);
                }
            }
            catch (Exception)
            {
                throw;
            }
            finally
            {
                if (cmd != null)
                    cmd.Dispose();
            }
        }

        public void Update(entidadeClasse objClasse)
        {
            MySqlCommand cmd = null;

            IGerenciadorTransacao objGerenciadorTransacao = null;
            ConexaoBD objconexaoBD = null;

            try
            {
                objconexaoBD = new ConexaoBD();

                objconexaoBD.SetarConexaoBanco(TipoBDConexao.fat_BD);

                using (objGerenciadorTransacao = FabricaGerenciadorTransacao.GetGerenciador(TipoBDGerenciador.MySql))
                {
                    vFILTER = vFILTER + "CODIGO        = ?CODIGO , ";
                    vFILTER = vFILTER + "DESCRICAO         = ?DESCRICAO,  ";
                    vFILTER = vFILTER + "CONTA_FATURAMENTO         = ?CONTA_FATURAMENTO,  ";
                    vFILTER = vFILTER + "CONTA_FATURAMENTO_PARC         = ?CONTA_FATURAMENTO_PARC  ";

                    vAND = vAND + "AND CODIGO       = ?CODIGOOLD ";

                    cmd = new MySqlCommand(this.QueryUpdate);

                    cmd.Parameters.AddWithValue("?CODIGO", objClasse.CODIGO.ToString().ToUpper());
                    cmd.Parameters.AddWithValue("?CODIGOOLD", objClasse.GRUPOTAR.ToString().ToUpper());
                    cmd.Parameters.AddWithValue("?DESCRICAO", objClasse.DESCRICAO.ToString().ToUpper());
                    cmd.Parameters.AddWithValue("?CONTA_FATURAMENTO", objClasse.CONTA_FATURAMENTO.ToString().ToUpper());
                    cmd.Parameters.AddWithValue("?CONTA_FATURAMENTO_PARC", objClasse.CONTA_FATURAMENTO_PARC.ToString().ToUpper());

                    objGerenciadorTransacao.Execute(cmd);
                }
            }
            catch (Exception)
            {
                throw;
            }
            finally
            {
                if (cmd != null)
                    cmd.Dispose();
            }
        }

        public DataTable Select(entidadeClasse objClasse)
        {
            DataTable dt = null;
            MySqlCommand cmd = null;
            IGerenciadorTransacao objGerenciadorTransacao = null;
            ConexaoBD objconexaoBD = null;

            try
            {
                objconexaoBD = new ConexaoBD();

                objconexaoBD.SetarConexaoBanco(TipoBDConexao.fat_BD);

                using (objGerenciadorTransacao = FabricaGerenciadorTransacao.GetGerenciador(TipoBDGerenciador.MySql))
                {
                    vFILTER = vFILTER + "CODIGO, ";
                    vFILTER = vFILTER + "DESCRICAO,  ";
                    vFILTER = vFILTER + "CONTA_FATURAMENTO,  ";
                    vFILTER = vFILTER + "CONTA_FATURAMENTO_PARC  ";

                    vINNERJOIN = " ";

                    vORDERBY = "ORDER BY CODIGO ";
                    vAND = " ";

                    cmd = new MySqlCommand(this.QuerySelect);

                    dt = objGerenciadorTransacao.GetDataTable(cmd);
                }

                return dt;
            }
            catch (Exception)
            {
                throw;
            }
            finally
            {
                if (cmd != null)
                    cmd.Dispose();
            }
        }

        public DataTable Select_1(entidadeClasse objClasse)
        {
            DataTable dt = null;
            MySqlCommand cmd = null;
            IGerenciadorTransacao objGerenciadorTransacao = null;
            ConexaoBD objconexaoBD = null;

            try
            {
                objconexaoBD = new ConexaoBD();

                objconexaoBD.SetarConexaoBanco(TipoBDConexao.fat_BD);

                using (objGerenciadorTransacao = FabricaGerenciadorTransacao.GetGerenciador(TipoBDGerenciador.MySql))
                {
                    vFILTER = vFILTER + "CODIGO, ";
                    vFILTER = vFILTER + "DESCRICAO  ";

                    vINNERJOIN = " ";

                    vORDERBY = " ";

                    vAND = vAND + "AND CODIGO = ?CODIGO";

                    cmd = new MySqlCommand(this.QuerySelect);

                    cmd.Parameters.AddWithValue("?CODIGO", objClasse.CODIGO.ToString().ToUpper());

                    dt = objGerenciadorTransacao.GetDataTable(cmd);


                }

                return dt;
            }
            catch (Exception)
            {
                throw;
            }
            finally
            {
                if (cmd != null)
                    cmd.Dispose();
            }
        }

        public void Delete(entidadeClasse objClasse)
        {
            MySqlCommand cmd = null;

            IGerenciadorTransacao objGerenciadorTransacao = null;

            ConexaoBD objconexaoBD = null;

            try
            {
                objconexaoBD = new ConexaoBD();

                objconexaoBD.SetarConexaoBanco(TipoBDConexao.fat_BD);

                using (objGerenciadorTransacao = FabricaGerenciadorTransacao.GetGerenciador(TipoBDGerenciador.MySql))
                {

                    vORDERBY = " ";

                    vAND = vAND + "AND CODIGO  = ?CODIGO ";

                    cmd = new MySqlCommand(this.QueryDelete);

                    cmd.Parameters.AddWithValue("?CODIGO", objClasse.CODIGO);

                    objGerenciadorTransacao.Execute(cmd);
                }
            }
            catch (Exception)
            {
                throw;
            }
            finally
            {
                if (cmd != null)
                    cmd.Dispose();
            }
        }

        public DataTable SelectOthersTables(entidadeClasse objClasse)
        {
            DataTable dt = null;
            MySqlCommand cmd = null;
            IGerenciadorTransacao objGerenciadorTransacao = null;
            ConexaoBD objconexaoBD = null;

            try
            {
                objconexaoBD = new ConexaoBD();

                objconexaoBD.SetarConexaoBanco(TipoBDConexao.fat_BD);

                using (objGerenciadorTransacao = FabricaGerenciadorTransacao.GetGerenciador(TipoBDGerenciador.MySql))
                {
                    vFILTER = vFILTER + "CODIGO, ";
                    vFILTER = vFILTER + "CONCAT(CODIGO,' - ', DESCRICAO) AS DESCRICAO  ";

                    vINNERJOIN = " ";

                    vORDERBY = " ";

                    vAND = vAND + "AND  CODIGO NOT IN('9100','9102','9104','9105','9106') ";

                    cmd = new MySqlCommand(this.QuerySelect);

                    dt = objGerenciadorTransacao.GetDataTable(cmd);
                }

                return dt;
            }
            catch (Exception)
            {
                throw;
            }
            finally
            {
                if (cmd != null)
                    cmd.Dispose();
            }
        }

        #endregion

        #region " Comandos SQL "

        StringBuilder sb = new StringBuilder();

        protected string QueryInsert
        {
            get
            {
                this.sb.Clear();

                this.sb.AppendLine("INSERT INTO  ");
                this.sb.AppendLine("CLASSE SET  ");
                this.sb.AppendLine(vFILTER);

                return sb.ToString();
            }
        }

        protected string QueryUpdate
        {
            get
            {
                this.sb.Clear();

                this.sb.AppendLine("UPDATE  ");
                this.sb.AppendLine("CLASSE SET  ");
                this.sb.AppendLine(vFILTER);
                this.sb.AppendLine("WHERE 1 = 1 ");
                this.sb.AppendLine(vAND);

                return sb.ToString();
            }
        }

        protected string QueryDelete
        {
            get
            {
                this.sb.Clear();

                this.sb.AppendLine("DELETE FROM CLASSE ");
                this.sb.AppendLine("WHERE 1 = 1 ");
                this.sb.AppendLine(vAND);
                this.sb.AppendLine(vORDERBY);

                return sb.ToString();
            }
        }

        protected string QuerySelect
        {
            get
            {
                this.sb.Clear();

                this.sb.AppendLine("SELECT ");
                this.sb.AppendLine(vFILTER);
                this.sb.AppendLine("FROM ");
                this.sb.AppendLine("CLASSE  ");
                this.sb.AppendLine(vINNERJOIN);
                this.sb.AppendLine("WHERE 1 = 1  ");
                this.sb.AppendLine(vAND);
                this.sb.AppendLine(vORDERBY);

                return sb.ToString();
            }
        }

        #endregion


    }
}
